#include<bits/stdc++.h>
#define maxN 200000
#define maxM 100001
#define mod 998244353

using namespace std;

int poww(int osnova, int izlozilac) {
    if(izlozilac == 0) {
        return 1;
    }

    return osnova * poww(osnova, izlozilac - 1);
}
int main() {
    int n, m;
    int b[maxM];
    int a[maxN];

    cin >> n >> m;

    for(int i = 1; i <= m; ++i) {
        cin >> b[i];
    }
    for(int i = 1; i <= n; ++i) {
        a[i] = i;
    }
    int c; cin >> c;

    for(int i = 0; i <= n - m; ++i) {
        for(int j = 1; j <= m; ++j) {
            a[i + b[j]] = a[i + j] % mod;
        }
    }
    int suma = 0;

    for(int i = 1; i <= n; ++i) {
        suma += (poww(c, i) % mod) * (a[i]) % mod;
    }

    cout << suma;
}